diff --git a/src/cmd/ksh93/sh/lex.c b/src/cmd/ksh93/sh/lex.c
index 4c773a396ca4..a2aa1572ed85 100644
--- a/src/cmd/ksh93/sh/lex.c
+++ b/src/cmd/ksh93/sh/lex.c
@@ -918,22 +918,30 @@ int sh_lex(Lex_t *lp) {
             }
             case S_MOD2: {
                 if (lp->kiafile) refvar(lp, 1);
-                if (c != ':' && (n = fcgetc()) > 0) {
-                    if (n != c) c = 0;
-                    if (!c || (n = fcgetc()) > 0) {
-                        fcseek(-LEN);
-                        if (n == LPAREN) {
-                            if (c != '%') {
-                                lp->token = n;
-                                sh_syntax(lp);
-                            } else if (lp->lexd.warn) {
-                                errormsg(SH_DICT, ERROR_warn(0), e_lexquote, shp->inlineno, '%');
+                // Correctly handle issue #475 cases by placing the lexer in
+                // the correct mode when analyzing a modifier with parameter
+                // expansions.
+                if (c == '-' || c == '+' || c == '=') {
+                    mode = ST_QUOTE;
+                } else {
+                    if (c != ':' && (n = fcgetc()) > 0) {
+                        if (n != c) c = 0;
+                        if (!c || (n = fcgetc()) > 0) {
+                            fcseek(-LEN);
+                            if (n == LPAREN) {
+                                if (c != '%') {
+                                    lp->token = n;
+                                    sh_syntax(lp);
+                                } else if (lp->lexd.warn) {
+                                    errormsg(SH_DICT, ERROR_warn(0), e_lexquote, shp->inlineno,
+                                             '%');
+                                }
                             }
                         }
                     }
+                    lp->lex.nestedbrace = 0;
+                    mode = ST_NESTED;
                 }
-                lp->lex.nestedbrace = 0;
-                mode = ST_NESTED;
                 continue;
             }
             case S_LBRA: {
diff --git a/src/cmd/ksh93/tests/modifiers.sh b/src/cmd/ksh93/tests/modifiers.sh
index 117e4f055787..688ebde3eeb3 100644
--- a/src/cmd/ksh93/tests/modifiers.sh
+++ b/src/cmd/ksh93/tests/modifiers.sh
@@ -44,3 +44,41 @@ unset foo
 foo="non-null value"
 [[ ${foo:+bar} == "bar" ]]  || log_error  '${foo:+bar} not bar when foo is not null'
 [[ ${foo+bar} == "bar" ]]  || log_error  '${foo+bar} not bar when foo is not null'
+
+# Check for regressions on issue #475 where parens after `-', `+', and `=' were causing syntax errors
+unset foo
+[[ ${foo:-(bar)} == "(bar)" ]]  || log_error  '${foo:-(bar)} not (bar) when foo is not set'
+
+unset foo
+[[ ${foo-(bar)} == "(bar)" ]] || log_error '${foo-(bar)} not (bar) when foo is not set'
+
+unset foo
+[[ ${foo-(wor)d} == "(wor)d" ]] || log_error '${foo-(wor)d} not (wor)d when foo is not set'
+
+unset foo
+[[ ${foo-w(or)d} == "w(or)d" ]] || log_error '${foo-w(or)d} not w(or)d when foo is not set'
+
+unset foo
+[[ ${foo-w(ord} == "w(ord" ]] || log_error '${foo-w(ord} not w(ord when foo is not set'
+
+ unset foo
+[[ ${foo-wor)d} == "wor)d" ]] || log_error '${foo-wor)d} not wor)d when foo is not set'
+
+foo=""
+[[ ${foo-(bar)} == "" ]]  || log_error  '${foo-(bar)} not "" when foo is null'
+
+unset foo
+[[ ${foo:+(bar)} == "" ]]  || log_error '${foo:+(bar)} not null when foo is not set'
+
+unset foo
+[[ ${foo+(bar)} == "" ]]  || log_error '${foo+(bar)} not null when foo is not set'
+
+foo="non-null value"
+[[ ${foo:+(bar)} == "(bar)" ]]  || log_error  '${foo:+(bar)} not (bar) when foo is not null'
+[[ ${foo+(bar)} == "(bar)" ]]  || log_error  '${foo+(bar)} not (bar) when foo is not null'
+
+unset foo
+[[ ${foo=(word)} == "(word)" ]] || log_error '${foo=(word)} not (word) when foo is not set'
+
+unset foo
+[[ ${foo=w(or)d} == "w(or)d" ]] || log_error '${foo=w(or)d} not w(or)d when foo is not set'
